import gdal
import matplotlib.pyplot as plt
import numpy as np
import os

## set your work directory
os.chdir('/Users/Shared/GE529-2022/data/')

# open dataset
lai = gdal.Open('MOD15A2H.A2002225.h18v04.tif')

# read raster as numpy array
laiArray = lai.ReadAsArray()
'''
# plot the LAI layer
plt.imshow(laiArray, interpolation='none')
plt.title('MODIS LAI data: DOY 225 2002')
plt.colorbar()
plt.show()

plt.imshow(laiArray, interpolation='none', vmin=0, vmax=70) 
plt.title('MODIS LAI data: DOY 225 2002')
plt.colorbar()
plt.show()
'''

qc = gdal.Open('MOD15A2H.A2002225.h18v04.FparLai_QC.tif')
qcArray = qc.ReadAsArray()
# & Binary AND, 224 == 11100000, get 5,6,7 bit from qc layer 
qcArray = qcArray & 224
# >> Binary Right Shift, right shift 5,6,7 bit, 11100000 will become 111
qcArray = qcArray >>5
# check the output array, you will find that only the {5,6,7} bits were extracted from original pixel values. 
np.unique(qcArray)
# you will get: array([0, 1, 3, 4, 7], dtype=uint8)

mask = qcArray==0
# Select a black/white colormap
cmap = plt.cm.gray
# plot the data
plt.imshow(mask, interpolation='nearest', cmap=cmap)
# add a colorbar
plt.colorbar(ticks=[0,1])
plt.show()

laiArray = laiArray * 0.1
laim = np.ma.array(laiArray, mask=qcArray)
print("[ STATS ] = Minimum={0}, Maximum={1}, Mean={2}, StdDev={3}".format(laim.min(),laim.max(),laim.mean(),laim.std()))

cmap=plt.cm.Greens
plt.imshow(laim, cmap=cmap, interpolation='nearest',vmin=0, vmax=7)
plt.title('MODIS LAI (only good data)')
plt.colorbar()
plt.show()



