import gdal
import matplotlib.pyplot as plt
import numpy as np
import os

## set your work directory
os.chdir('/Users/Shared/GE529-2022/data/')

# open 2002 dataset
lai2002 = gdal.Open('lai_mosaic_2002.tif')
laiArray2002 = lai2002.ReadAsArray()

qc2002 = gdal.Open('qc_mosaic_2002.tif')
qcArray2002 = qc2002.ReadAsArray()

qcArray2002 = qcArray2002 & 224
qcArray2002 = qcArray2002 >>5
np.unique(qcArray2002)
mask2002 = qcArray2002==0

laiArray2002 = laiArray2002 * 0.1
laim2002 = np.ma.array(laiArray2002, mask=qcArray2002)
print("[ STATS ] = Minimum={0}, Maximum={1}, Mean={2}, StdDev={3}".format(laim2002.min(),laim2002.max(),laim2002.mean(),laim2002.std()))

# compute 2002 histogram
laim2002 = laim2002.compressed() 
plt.hist(laim2002, bins=100) 
plt.show()


# open 2003 dataset
lai2003 = gdal.Open('lai_mosaic_2003.tif')
laiArray2003 = lai2003.ReadAsArray()

qc2003 = gdal.Open('qc_mosaic_2003.tif')
qcArray2003 = qc2003.ReadAsArray()

qcArray2003 = qcArray2003 & 224
qcArray2003 = qcArray2003 >>5
np.unique(qcArray2003)
mask2003 = qcArray2003==0

laiArray2003 = laiArray2003 * 0.1
laim2003 = np.ma.array(laiArray2003, mask=qcArray2003)

# compute histogram
laim2003 = laim2003.compressed()
plt.hist(laim2002, bins=100, color='r', label='LAI 2002') 
plt.hist(laim2003, bins=100, color='b', alpha=0.5, label='LAI 2003')
plt.legend()
plt.show()

# plot the data
laim2002 = np.ma.array(laiArray2002, mask=qcArray2002)
cmap=plt.cm.jet
plt.imshow(laim2002, cmap=cmap, interpolation='nearest',vmin=0, vmax=7)
plt.title('MODIS LAI: DOY 225 2002')
plt.colorbar()
plt.show()

laim2003 = np.ma.array(laiArray2003, mask=qcArray2003)
cmap=plt.cm.jet
plt.imshow(laim2003, cmap=cmap, interpolation='nearest',vmin=0, vmax=7)
plt.title('MODIS LAI: DOY 225 2003')
plt.colorbar()
plt.show()

# show drought affected pixels
drought=np.ma.array((laim2003-laim2002), mask=laim2003>laim2002*0.75)
cmap=plt.cm.jet
plt.imshow(drought,cmap=cmap,interpolation='nearest',vmin=-7, vmax=0)
plt.colorbar()
plt.show()

